package com.jiuqi.db;

import java.util.Calendar;
import java.util.Date;

/* loaded from: com_jiuqi_db.jar:com/jiuqi/db/DBFunction.class */
public abstract class DBFunction {
    private static final String left_parenthesis = "(";
    private static final String right_parenthesis = ")";
    private static final String comma = ",";
    private static final String FUNC_NAME_ABS = "ABS";
    private static final String FUNC_NAME_ACOS = "ACOS";
    private static final String FUNC_NAME_ASIN = "ASIN";
    private static final String FUNC_NAME_ATAN = "ATAN";
    private static final String FUNC_NAME_ATAN2 = "ATAN2";
    private static final String FUNC_NAME_COS = "COS";
    private static final String FUNC_NAME_EXP = "EXP";
    private static final String FUNC_NAME_FLOOR = "FLOOR";
    private static final String FUNC_NAME_POWER = "POWER";
    private static final String FUNC_NAME_ROUND = "ROUND";
    private static final String FUNC_NAME_SIGN = "SIGN";
    private static final String FUNC_NAME_SIN = "SIN";
    private static final String FUNC_NAME_LOWER = "LOWER";
    private static final String FUNC_NAME_LTRIM = "LTRIM";
    private static final String FUNC_NAME_REPLACE = "REPLACE";
    private static final String FUNC_NAME_RTRIM = "RTRIM";
    private static final String FUNC_NAME_UPPER = "UPPER";
    private static final String FUNC_NAME_ASCII = "ASCII";
    private StringBuffer formatbuffer = new StringBuffer();

    public abstract String strLinkSymbol();

    public abstract boolean supportEmptyString();

    public abstract String ceiling(String str);

    public abstract String ln(String str);

    public abstract String log10(String str);

    public abstract String mod(String str, String str2);

    public abstract String chr(String str);

    public abstract String pos(String str, String str2);

    public abstract String left(String str, String str2);

    public abstract String right(String str, String str2);

    public abstract String str(String str);

    public abstract String substr(String str, String str2, String str3);

    public abstract String len(String str);

    public abstract String val(String str);

    public abstract String date(Date date);

    protected String format(String functionName, String expression) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(functionName);
        this.formatbuffer.append(left_parenthesis);
        this.formatbuffer.append(expression);
        this.formatbuffer.append(right_parenthesis);
        return this.formatbuffer.toString();
    }

    protected String format(String functionName, String expression1, String expression2) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(functionName);
        this.formatbuffer.append(left_parenthesis);
        this.formatbuffer.append(expression1);
        this.formatbuffer.append(comma);
        this.formatbuffer.append(expression2);
        this.formatbuffer.append(right_parenthesis);
        return this.formatbuffer.toString();
    }

    protected String format(String functionName, String expression1, String expression2, String expression3) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(functionName);
        this.formatbuffer.append(left_parenthesis);
        this.formatbuffer.append(expression1);
        this.formatbuffer.append(comma);
        this.formatbuffer.append(expression2);
        this.formatbuffer.append(comma);
        this.formatbuffer.append(expression3);
        this.formatbuffer.append(right_parenthesis);
        return this.formatbuffer.toString();
    }

    protected String formatmidopt(String expression1, String operationSymbol, String expression2) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(expression1);
        this.formatbuffer.append(operationSymbol);
        this.formatbuffer.append(expression2);
        return this.formatbuffer.toString();
    }

    public String abs(String numeric_expression) {
        return format(FUNC_NAME_ABS, numeric_expression);
    }

    public String acos(String numeric_expression) {
        return format(FUNC_NAME_ACOS, numeric_expression);
    }

    public String asin(String numeric_expression) {
        return format(FUNC_NAME_ASIN, numeric_expression);
    }

    public String atan(String numeric_expression) {
        return format(FUNC_NAME_ATAN, numeric_expression);
    }

    public String atan2(String expression) {
        return format(FUNC_NAME_ATAN2, expression);
    }

    public String cos(String numeric_expression) {
        return format(FUNC_NAME_COS, numeric_expression);
    }

    public String exp(String numeric_expression) {
        return format(FUNC_NAME_EXP, numeric_expression);
    }

    public String floor(String expression) {
        return format(FUNC_NAME_FLOOR, expression);
    }

    public String power(String numeric_expression1, String numeric_expression2) {
        return format(FUNC_NAME_POWER, numeric_expression1, numeric_expression2);
    }

    public String round(String numeric_expression) {
        return round(numeric_expression, "0");
    }

    public String round(String numeric_expression, String int_expression) {
        return format(FUNC_NAME_ROUND, numeric_expression, int_expression);
    }

    public String sign(String numeric_expression) {
        return format(FUNC_NAME_SIGN, numeric_expression);
    }

    public String sin(String numeric_expression) {
        return format(FUNC_NAME_SIN, numeric_expression);
    }

    public String lower(String str_expression) {
        return format(FUNC_NAME_LOWER, str_expression);
    }

    public String ltrim(String str_expression) {
        return format(FUNC_NAME_LTRIM, str_expression);
    }

    public String replace(String source_str_expression, String search_str_expression, String replace_str_expression) {
        return format(FUNC_NAME_REPLACE, source_str_expression, search_str_expression, replace_str_expression);
    }

    public String rtrim(String str_expression) {
        return format(FUNC_NAME_RTRIM, str_expression);
    }

    public String upper(String str_expression) {
        return format(FUNC_NAME_UPPER, str_expression);
    }

    public String ascii(String char_expression) {
        return format(FUNC_NAME_ASCII, char_expression);
    }

    public String date(Calendar dateVal) {
        Date d = dateVal.getTime();
        return date(d);
    }
}
